/*
 * Copyright (C) 2012 daniel
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package darwin.renderer.opengl.buffer;

/**
 *
 * @author daniel
 */
/**
 * The Usage flag indicates what the source and destination of the data will be.
 */
public enum Usage
{
    //The ordering of the elements must not be changed

    /**
     * The data is generated by the application and passed to GL for rendering.
     */
    DRAW,
    /**
     * The data is generated by GL, and read back by the application. It is not
     * used by GL.
     */
    READ,
    /**
     * The data is generated by GL, and copied into the BO to be used for
     * rendering.
     */
    COPY;
    final int glEnumeration = ordinal();
}
